//
//  RWWallpaperService.m
//  WallpaperBrowser
//
//  Created by Brian Moakley on 3/10/14.
//  Copyright (c) 2014 Razeware LLC. All rights reserved.
//

#import "RWTWallpaperService.h"

@implementation RWTWallpaperService

-(void) connect
{
    NSString *webService = @"http://www.raywenderlich.com/demos/simple_post/simple_post.php";
    NSString *webServiceWithParam = [NSString stringWithFormat:@"%@?wallpaper=%d", webService, self.wallpaperID];
    NSURL *url = [NSURL URLWithString:webServiceWithParam];
    
    
    NSURLSessionConfiguration *sessionConfig = [NSURLSessionConfiguration defaultSessionConfiguration];
    NSURLSession *session = [NSURLSession sessionWithConfiguration:sessionConfig delegate:self delegateQueue:nil];
    NSURLSessionDataTask *jsonData = [session dataTaskWithURL:url completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
        NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *) response;
        if (!error && httpResponse.statusCode == 200)
        {
            NSError *jsonError;
            NSDictionary *json = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingAllowFragments error:&jsonError];
            if (!jsonError)
            {
                NSNumber *result = json[@"result"];
                if (result && result.intValue == 1)
                {
                    dispatch_async(dispatch_get_main_queue(), ^{
                        if (self.delegate)
                        {
                            [self.delegate allowAccess];
                        }
                    });
                }
                else
                {
                    if (self.delegate)
                    {
                        [self.delegate denyAccess:nil];
                    }
                }
            }
            else
            {
                dispatch_async(dispatch_get_main_queue(), ^{
                    if (self.delegate)
                    {
                        [self.delegate denyAccess:nil];
                    }
                });
            }
        }
    }];
    [jsonData resume];
}

@end
